/*
 *	Functions for analysing x64 architecture systems
*/

#include "../../globals.h"

/*
 * Some alchemy:
 */

/*
 * Function that manages mapping from linear to physical address space.
 * 
 */


/*
 * Function for verifying if given address contains structure list_head.
 */



/*
 *  i386_lin_verify_vfsmount (pointer to vfsmount structure)
 *  return 0 on success, otherwise -1
 *
 */


/*
 *  i386_lin_verify_qstr (pointer to "qstr" structure )
 *  return 0 on success, otherwise error
 *
 *  Used for listing of open files per process.
 */

/*
 *  i386_lin_verify_dentry (pointer to "dentry" structure )
 *  return 0 on success, otherwise -1
 *  determined distances are saved into image1
 *
 */

/*
 *  i386_lin_determine_up_to_path (pointer to "tasks" list_head in task_struct )
 *  return 0 on success, otherwise -1
 *  determined distances are saved into image1
 *
 *  function that tries to determine distances in structures needed
 *  for listing of open files per process up to f_path structure.
 */

/*
 *  determine_open_files (pointer to "tasks" list_head in task_struct )
 *  return 0 on success, otherwise -1
 *
 *  function that tries to determine distances in all structures needed
 *  for listing of open files per process. 
 *  This will definitely not work in 2.4 kernels.
 */

/*
 *  i386_lin_verify_task_struct (pointer to "comm" field of task_struct )
 *  return 0 on success, otherwise -1
 */

/*
 *  i386_lin_verify_module (pointer to "name" field of module )
 *  return distance between name and list_head in bytes on success, otherwise < 0
 *  
 */

/*
 * Function for verifying if given address contains VPT 
 * (resp. PaGeDirectory) of some process.
 */

/*
 * Function for verifying if given address contains system VPT 
 * (resp. PaGeDirectory)
 *
 */

/*
 * Function for finding VPT of given process 
 * (resp. PaGeDirectory).
 *
 * This function is assumed to be called only once.
 * When distances used in analyzed image are known,
 * it is faster and safer to use them directly.
 */

/*
 * Function that tries to determine general information 
 * about analyzed image.
 *
 * for now, only system VPT is found.
 *
 * determine ()
 * return 0 on success, otherwise error > 0
 * Discovered information are saved in global structure image1.
 *
 */

/*
 * Function that tries to determine linux-specific information 
 * about analyzed image.
 */

/*
 * Function that tries to determine linux module-specific 
 * information about analyzed image.
 */
